
import logging
from pyvisdk.exceptions import InvalidArgumentError

########################################
# Automatically generated, do not edit.
########################################

log = logging.getLogger(__name__)

def DVSFailureCriteria(vim, *args, **kwargs):
    '''This data object type describes the network adapter failover detection
    algorithm for a network adapter team.'''

    obj = vim.client.factory.create('{urn:vim25}DVSFailureCriteria')

    # do some validation checking...
    if (len(args) + len(kwargs)) < 1:
        raise IndexError('Expected at least 2 arguments got: %d' % len(args))

    required = [ 'inherited' ]
    optional = [ 'checkBeacon', 'checkDuplex', 'checkErrorPercent', 'checkSpeed', 'fullDuplex',
        'percentage', 'speed', 'dynamicProperty', 'dynamicType' ]

    for name, arg in zip(required+optional, args):
        setattr(obj, name, arg)

    for name, value in kwargs.items():
        if name in required + optional:
            setattr(obj, name, value)
        else:
            raise InvalidArgumentError("Invalid argument: %s.  Expected one of %s" % (name, ", ".join(required + optional)))

    return obj
