
import logging
from pyvisdk.exceptions import InvalidArgumentError

########################################
# Automatically generated, do not edit.
########################################

log = logging.getLogger(__name__)

def HostInternetScsiHbaAuthenticationProperties(vim, *args, **kwargs):
    '''The authentication settings for this host bus adapter or target.'''

    obj = vim.client.factory.create('{urn:vim25}HostInternetScsiHbaAuthenticationProperties')

    # do some validation checking...
    if (len(args) + len(kwargs)) < 1:
        raise IndexError('Expected at least 2 arguments got: %d' % len(args))

    required = [ 'chapAuthEnabled' ]
    optional = [ 'chapAuthenticationType', 'chapInherited', 'chapName', 'chapSecret',
        'mutualChapAuthenticationType', 'mutualChapInherited', 'mutualChapName',
        'mutualChapSecret', 'dynamicProperty', 'dynamicType' ]

    for name, arg in zip(required+optional, args):
        setattr(obj, name, arg)

    for name, value in kwargs.items():
        if name in required + optional:
            setattr(obj, name, value)
        else:
            raise InvalidArgumentError("Invalid argument: %s.  Expected one of %s" % (name, ", ".join(required + optional)))

    return obj
