
import logging
from pyvisdk.exceptions import InvalidArgumentError

########################################
# Automatically generated, do not edit.
########################################

log = logging.getLogger(__name__)

def HostMountInfo(vim, *args, **kwargs):
    '''The HostMountInfo data object provides information related to a configured
    mount point. This object does not include information about the mounted file
    system. (See HostFileSystemMountInfo.)'''

    obj = vim.client.factory.create('{urn:vim25}HostMountInfo')

    # do some validation checking...
    if (len(args) + len(kwargs)) < 1:
        raise IndexError('Expected at least 2 arguments got: %d' % len(args))

    required = [ 'accessMode' ]
    optional = [ 'accessible', 'mounted', 'path', 'dynamicProperty', 'dynamicType' ]

    for name, arg in zip(required+optional, args):
        setattr(obj, name, arg)

    for name, value in kwargs.items():
        if name in required + optional:
            setattr(obj, name, value)
        else:
            raise InvalidArgumentError("Invalid argument: %s.  Expected one of %s" % (name, ", ".join(required + optional)))

    return obj
