
import logging
from pyvisdk.exceptions import InvalidArgumentError

########################################
# Automatically generated, do not edit.
########################################

log = logging.getLogger(__name__)

def InventoryDescription(vim, *args, **kwargs):
    '''Data object to capture all information needed to describe a sample inventory.'''

    obj = vim.client.factory.create('{urn:vim25}InventoryDescription')

    # do some validation checking...
    if (len(args) + len(kwargs)) < 2:
        raise IndexError('Expected at least 3 arguments got: %d' % len(args))

    required = [ 'numHosts', 'numVirtualMachines' ]
    optional = [ 'numClusters', 'numCpuDev', 'numDiskDev', 'numNetDev', 'numResourcePools',
        'numvCpuDev', 'numvDiskDev', 'numvNetDev', 'dynamicProperty', 'dynamicType' ]

    for name, arg in zip(required+optional, args):
        setattr(obj, name, arg)

    for name, value in kwargs.items():
        if name in required + optional:
            setattr(obj, name, value)
        else:
            raise InvalidArgumentError("Invalid argument: %s.  Expected one of %s" % (name, ", ".join(required + optional)))

    return obj
